#include "unit1.h"
//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
        return 1;
}
//---------------------------------------------------------------------------
//---     ------------------------------------------------
bool WriteData(HANDLE Port, Result Request)
{ DWORD Temp;

  WriteFile(Port,Request.Buffer,Request.Size,&Temp,&Ovrlp_wr); //   
  WaitForSingleObject(Ovrlp_wr.hEvent,20000);        //   20         
  if(GetOverlappedResult(Port,&Ovrlp_wr,&Temp,true)) return true;  //    -  
  else                                               return false; //  - 
}
//---------------------------------------------------------------------------
//---     ------------------------------------------------
Result ReadData(HANDLE Port, unsigned int Size)
{ COMSTAT    Status;
  DWORD      Temp, Mask;
  Result     Answer;

  Answer.Size=0;
  memset(Answer.Buffer,0,BUFSIZE); //   

  for(int i=0; i<1000; i++) //   1000 
  { ClearCommError(Port,&Temp,&Status); //  port_status
    Answer.Size=Status.cbInQue;   //-  
    if(Answer.Size>=Size)       //  ,    
    { ReadFile(Port,Answer.Buffer,Answer.Size,&Temp,&Ovrlp_rd);  //  - 
      return Answer;
    }
    Sleep(1);
  }
  Answer.Size=0;
  return Answer;
}
//---------------------------------------------------------------------------
//***************************************************************************
//***   ************************************************
//***************************************************************************
//---    ---------------------------------------------------
HANDLE ConnectPort(char *PortName)
{ HANDLE Port=INVALID_HANDLE_VALUE;
  DCB    dcb;  // DCB

  dcb.DCBlength=sizeof(DCB);
  //  .     nt-  
  // "\\.\PortName",      \    2 
  char OpenPortName[100]="\\\\.\\";
  strcat(OpenPortName,PortName);
  Port=CreateFile(OpenPortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port!=INVALID_HANDLE_VALUE)
  {     if(GetCommState(Port,&dcb)==0)
        {       CloseHandle(Port);
                Port=INVALID_HANDLE_VALUE;
        }
        else
        {       dcb.BaudRate=115200;              //
                dcb.ByteSize=8;                   //-  
                dcb.Parity=0;                     //  
                dcb.StopBits=2;                   //  
                dcb.fBinary=true;                 //  
                dcb.fOutxCtsFlow=false;           //  CTS
                dcb.fOutxDsrFlow=false;           //  DSR
                dcb.fDtrControl=DTR_CONTROL_DISABLE;  // DTR
                dcb.fDsrSensitivity=false;            //  DSR
                dcb.fNull=false;                      //  
                dcb.fRtsControl=RTS_CONTROL_DISABLE;  // RTS
                dcb.fAbortOnError=false;   //  /  
                if(SetCommState(Port,&dcb)==0)
                {       CloseHandle(Port);
                        Port=INVALID_HANDLE_VALUE;
                }
        }
  }
  return Port;
}
//---------------------------------------------------------------------------
//---    ---------------------------------------------------
HANDLE DisconnectPort(HANDLE Port)
{ if(Port!=INVALID_HANDLE_VALUE)
  {     CloseHandle(Port);
        Port=INVALID_HANDLE_VALUE;
  }
  return Port;
}
//---------------------------------------------------------------------------
//--- COMMON ----------------------------------------------------------------
//---------------------------------------------------------------------------
//---   -----------------------------------------------------------
unsigned char ResetDevice(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x0;                //   (0x00 - ResetDevice)
  if(WriteData(Port,Request))           //   UART
  {     if(Control==true)               //   
        {        Answer = ReadData(Port,1);  //  1   UART
                 if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                 else return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF;      //   (WriteError)
}
//---------------------------------------------------------------------------
//---   I2C --------------------------------------------------
unsigned char InterfaceChoiceI2C(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x1;                //   (0x01 - InterfaceChoiceI2C)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   SPI --------------------------------------------------
unsigned char InterfaceChoiceSPI(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x2;                //   (0x02 - InterfaceChoiceSPI)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   1W ---------------------------------------------------
unsigned char InterfaceChoice1W(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x3;                //   (0x03 - InterfaceChoice1W)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    ------------------------------------------------
unsigned char ReadError(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x4;                //   (0x04 - ReadError)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
        else               return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//--- C   EPROM ----------------------------------------
unsigned char SaveToEPROM(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x5;                //   (0x05 - SaveToEPROM)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    EPROM  --------------------------------
Result ReadFromEPROM(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x6;                //   (0x06 - ReadFromEPROM)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,6);  //  6   UART
        if(Answer.Size==0)
        {       Answer.Buffer[0]=0xFE; //   (ReadError)
        }
        return Answer;              //  
  }
  else
  { Answer.Size=0;
    Answer.Buffer[0]=0xFF; //   (WriteError)
    return Answer;
  }
}
//---------------------------------------------------------------------------
//---   -------------------------------------------------------
unsigned char EnableReports(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x7;                //   (0x07 - EnableReports)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
        else               return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   ------------------------------------------------------
unsigned char DisableReports(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x8;                //   (0x08 - DisableReports)
  if(WriteData(Port,Request))           //   UART
  {     return 0x0;                     //   
  }
  else  return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    -------------------------------------------
unsigned char EnableAutoload(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x9;                //   (0x09 - EnableAutoload)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    -------------------------------------------
unsigned char DisableAutoload(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x0A;               //   (0x0A - DisableAutoload)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    ------------------------------------------
unsigned char ReadCommonConfig(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x1A;              //   (0x1A - ReadCommonConfig)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
        else               return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    ------------------------------------------------------
unsigned char ReadVersion(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x1B;              //   (0x1B - ReadVersion)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
        else               return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//--- I/O -------------------------------------------------------------------
//---------------------------------------------------------------------------
//---  IO_0   ----------------------------------------
unsigned char IO0ConfigOutput(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x0B;               //   (0x0B - IO0ConfigOutput)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  IO_0   ----------------------------------------
unsigned char IO0ConfigInput(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x0C;               //   (0x0C - IO0ConfigInput)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  0   IO_0 ---------------------------------------------
unsigned char IO0Output0(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x0D;               //   (0x0D - IO0Output0)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  1   IO_0 ---------------------------------------------
unsigned char IO0Output1(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x0E;               //   (0x0E - IO0Output1)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  IO_1   ----------------------------------------
unsigned char IO1ConfigOutput(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x0F;               //   (0x0F - IO1ConfigOutput)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  IO_1   ----------------------------------------
unsigned char IO1ConfigInput(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x10;               //   (0x10 - IO1ConfigInput)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  0   IO_1 ---------------------------------------------
unsigned char IO1Output0(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x11;               //   (0x11 - IO1Output0)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  1   IO_1 ---------------------------------------------
unsigned char IO1Output1(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x12;               //   (0x12 - IO1Output1)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  IO_2   ----------------------------------------
unsigned char IO2ConfigOutput(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x13;               //   (0x13 - IO2ConfigOutput)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  IO_2   ----------------------------------------
unsigned char IO2ConfigInput(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x14;               //   (0x14 - IO2ConfigInput)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  0   IO_2 ---------------------------------------------
unsigned char IO2Output0(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x15;               //   (0x15 - IO2Output0)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  1   IO_2 ---------------------------------------------
unsigned char IO2Output1(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x16;               //   (0x16 - IO2Output1)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   IO_0 ----------------------------------------------
unsigned char TestIO_0(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x17;               //   (0x17 - TestIO_0)
  if(WriteData(Port,Request))          //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0)
        {       if      (Answer.Buffer[0]==0x0F) Answer.Buffer[0]=0;
                else if (Answer.Buffer[0]==0x8F) Answer.Buffer[0]=1;
                return Answer.Buffer[0]; //    -  
        }
        else    return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   IO_1 ----------------------------------------------
unsigned char TestIO_1(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x18;               //   (0x18 - TestIO_1)
  if(WriteData(Port,Request))          //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0)
        {       if      (Answer.Buffer[0]==0x0F) Answer.Buffer[0]=0;
                else if (Answer.Buffer[0]==0x8F) Answer.Buffer[0]=1;
                return Answer.Buffer[0]; //    -  
        }
        else    return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   IO_2 ----------------------------------------------
unsigned char TestIO_2(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x19;               //   (0x19 - TestIO_2)
  if(WriteData(Port,Request))          //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0)
        {       if      (Answer.Buffer[0]==0x0F) Answer.Buffer[0]=0;
                else if (Answer.Buffer[0]==0x8F) Answer.Buffer[0]=1;
                return Answer.Buffer[0]; //    -  
        }
        else    return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   IO_0 / IO_1   ------------------------------
unsigned char SetIOG(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x1C;               //   (0x1C - SetIOG)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//--- I2C -------------------------------------------------------------------
//---------------------------------------------------------------------------
//---  START  I2C --------------------------------------------------
unsigned char SendStart_I2C(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x20;               //   (0x20 - SendStart_I2C)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---  STOP  I2C --------------------------------------------------
unsigned char SendStop_I2C(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x21;               //   (0x21 - SendStop_I2C)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    I2C --------------------------------------------------
unsigned int SendByte_I2C(HANDLE Port, bool Control, unsigned char Byte)
{ Result        Request;        //    
  Result        Answer;         //    
  int           Temp;           //    
  //(   -    ,   - )
  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  if(Control==true)
  {     Request.Size=1;                       //  
        Request.Buffer[0]=0x22;               //   (0x22 - SendByte)
        if(WriteData(Port,Request))          //   UART
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0)
                {       Temp=Answer.Buffer[0]; //    - 
                        if(Temp==0)            //     
                        {       Request.Buffer[0]=Byte; //   ( )
                                if(WriteData(Port,Request))          //   UART
                                {       Answer = ReadData(Port,1);  //  1   UART
                                        if(Answer.Size!=0)
                                        {       Temp=Answer.Buffer[0]<<8;
                                                return Temp; //    -  
                                        }
                                        else
                                        {       Temp=0xFE<<8;
                                                return Temp; //   (ReadError)
                                        }
                                }
                                else //     
                                {       Temp=0xFF<<8; //   (WriteError)
                                        return Temp;
                                }
                        }
                        else    return Temp;  //   
                }
                else
                {       Temp=0xFE;
                        return Temp; //   (ReadError)
                }
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
  else
  {     Request.Size=2;                       //  
        Request.Buffer[0]=0x22;               //   (0x22 - SendByte)
        Request.Buffer[1]=Byte;               //   ( )
        if(WriteData(Port,Request))          //   UART
        {       Temp=0x0;
                return Temp; //    - ,   
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
}
//---------------------------------------------------------------------------
//---     (  ACK) ----------------------------------
Result ReadByteA_I2C(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Answer.Size=0;
  Request.Size=1;                       //  
  Request.Buffer[0]=0x23;              //   (0x23 - ReadByteA_I2C)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        return Answer;
  }
  else
  {     Answer.Buffer[0]=0xFF;  //   (WriteError)
        return Answer;          //    = 0
  }
}
//---------------------------------------------------------------------------
//---     (  ACK) ---------------------------------
Result ReadByte_I2C(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Answer.Size=0;
  Request.Size=1;                       //  
  Request.Buffer[0]=0x24;              //   (0x24 - ReadByte_I2C)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        return Answer;
  }
  else
  {     Answer.Buffer[0]=0xFF;  //   (WriteError)
        return Answer;          //    = 0
  }
}
//---------------------------------------------------------------------------
//---   CS -----------------------------------------------------
unsigned char ClearCS_I2C(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x25;               //   (0x25 - ClearCS_I2C)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   CS ---------------------------------------------------
unsigned char SetCS_I2C(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x26;               //   (0x26 - SetCS_I2C)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    CS ------------------------------------------
unsigned char ReadCS_I2C(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x27;               //   (0x27 - ReadCS_I2C)
  if(WriteData(Port,Request))          //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0)
        {       if      (Answer.Buffer[0]==0x0F) Answer.Buffer[0]=0;
                else if (Answer.Buffer[0]==0x8F) Answer.Buffer[0]=1;
                return Answer.Buffer[0]; //    -  
        }
        else    return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//--- SPI -------------------------------------------------------------------
//---------------------------------------------------------------------------
//---   SPI --------------------------------------------
unsigned int LoadConfig_SPI(HANDLE Port, bool Control, unsigned char Byte)
{ Result        Request;        //    
  Result        Answer;         //    
  int           Temp;           //    
  //(   -    ,   - )
  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  if(Control==true)
  {     Request.Size=1;                       //  
        Request.Buffer[0]=0x40;               //   (0x40 - LoadConfig_SPI)
        if(WriteData(Port,Request))          //   UART
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0)
                {       Temp=Answer.Buffer[0]; //    - 
                        if(Temp==0)            //     
                        {       Request.Buffer[0]=Byte; //   ( )
                                if(WriteData(Port,Request))          //   UART
                                {       Answer = ReadData(Port,1);  //  1   UART
                                        if(Answer.Size!=0)
                                        {       Temp=Answer.Buffer[0]<<8;
                                                return Temp; //    -  
                                        }
                                        else
                                        {       Temp=0xFE<<8;
                                                return Temp; //   (ReadError)
                                        }
                                }
                                else //     
                                {       Temp=0xFF<<8; //   (WriteError)
                                        return Temp;
                                }
                        }
                        else    return Temp;  //   
                }
                else
                {       Temp=0xFE;
                        return Temp; //   (ReadError)
                }
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
  else
  {     Request.Size=2;                       //  
        Request.Buffer[0]=0x40;               //   (0x40 - LoadConfig_SPI)
        Request.Buffer[1]=Byte;               //   ( )
        if(WriteData(Port,Request))          //   UART
        {       Temp=0x0;
                return Temp; //    - ,   
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
}
//---------------------------------------------------------------------------
//---   SPI -----------------------------------------------
unsigned char ReadConfig_SPI(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x41;              //   (0x41 - ReadConfig_SPI)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
        else               return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    SPI -------------------------------------------
unsigned int LoadPaketSize_SPI(HANDLE Port, bool Control, unsigned char Byte)
{ Result        Request;        //    
  Result        Answer;         //    
  int           Temp;           //    
  //(   -    ,   - )
  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  if(Control==true)
  {     Request.Size=1;                       //  
        Request.Buffer[0]=0x42;               //   (0x42 - LoadPaketSize_SPI)
        if(WriteData(Port,Request))          //   UART
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0)
                {       Temp=Answer.Buffer[0]; //    - 
                        if(Temp==0)            //     
                        {       Request.Buffer[0]=Byte; //   ( )
                                if(WriteData(Port,Request))          //   UART
                                {       Answer = ReadData(Port,1);  //  1   UART
                                        if(Answer.Size!=0)
                                        {       Temp=Answer.Buffer[0]<<8;
                                                return Temp; //    -  
                                        }
                                        else
                                        {       Temp=0xFE<<8;
                                                return Temp; //   (ReadError)
                                        }
                                }
                                else //     
                                {       Temp=0xFF<<8; //   (WriteError)
                                        return Temp;
                                }
                        }
                        else    return Temp;  //   
                }
                else
                {       Temp=0xFE;
                        return Temp; //   (ReadError)
                }
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
  else
  {     Request.Size=2;                       //  
        Request.Buffer[0]=0x42;               //   (0x42 - LoadPaketSize_SPI)
        Request.Buffer[1]=Byte;               //   ( )
        if(WriteData(Port,Request))          //   UART
        {       Temp=0x0;
                return Temp; //    - ,   
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
}
//---------------------------------------------------------------------------
//---    SPI -------------------------------------------
Result ReadPaketSize_SPI(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Answer.Size=0;
  Request.Size=1;                       //  
  Request.Buffer[0]=0x43;              //   (0x43 - ReadPaketSize_SPI)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        return Answer;              //      -     
  }
  else
  {     Answer.Buffer[0]=0xFF;  //   (WriteError)
        return Answer;          //    = 0
  }
}
//---------------------------------------------------------------------------
//---   SPI -------------------------------------------
unsigned int LoadPaket_SPI(HANDLE Port, bool Control, Result Input)
{ Result        Request;        //    
  Result        Answer;         //    
  int           Temp;           //    
  //(   -    ,   - )
  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  if(Control==true)
  {     Request.Size=1;                       //  
        Request.Buffer[0]=0x44;               //   (0x44 - LoadPaket_SPI)
        if(WriteData(Port,Request))          //   UART
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0)
                {       Temp=Answer.Buffer[0]; //    - 
                        if(Temp==0)            //     
                        {       Request=Input; //   ( )
                                if(WriteData(Port,Request))          //   UART
                                {       Answer = ReadData(Port,1);  //  1   UART
                                        if(Answer.Size!=0)
                                        {       Temp=Answer.Buffer[0]<<8;
                                                return Temp; //    -  
                                        }
                                        else
                                        {       Temp=0xFE<<8;
                                                return Temp; //   (ReadError)
                                        }
                                }
                                else //     
                                {       Temp=0xFF<<8; //   (WriteError)
                                        return Temp;
                                }
                        }
                        else    return Temp;  //   
                }
                else
                {       Temp=0xFE;
                        return Temp; //   (ReadError)
                }
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
  else
  {     Request.Size=Input.Size+1;            //  
        Request.Buffer[0]=0x44;               //   (0x44 - LoadPaket_SPI)
        for(unsigned int i=0; i<Input.Size; i++)       //   (    )
                Request.Buffer[i+1]=Input.Buffer[i];
        if(WriteData(Port,Request))           //   UART
        {       Temp=0x0;
                return Temp; //    - ,   
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
}
//---------------------------------------------------------------------------
//---   SPI ---------------------------------------------------
Result ReadPaket_SPI(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Answer.Size=0;
  Request.Size=1;                       //  
  Request.Buffer[0]=0x45;              //   (0x45 - ReadPaket_SPI)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,8);  //  8   UART
        return Answer;              //      -     
  }
  else
  {     Answer.Buffer[0]=0xFF;  //   (WriteError)
        return Answer;          //    = 0
  }
}
//---------------------------------------------------------------------------
//---    SPI ------------------------------------------------
unsigned char StartChange_SPI(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x46;               //   (0x46 - StartChange_SPI)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   SS -----------------------------------------------------
unsigned char ClearSS_SPI(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x47;               //   (0x47 - ClearSS_SPI)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---   SS ---------------------------------------------------
unsigned char SetSS_SPI(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x48;               //   (0x48 - SetSS_SPI)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    SS ------------------------------------------
unsigned char ReadSS_SPI(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x49;               //   (0x49 - ReadSS_SPI)
  if(WriteData(Port,Request))          //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0)
        {       if      (Answer.Buffer[0]==0x0F) Answer.Buffer[0]=0;
                else if (Answer.Buffer[0]==0x8F) Answer.Buffer[0]=1;
                return Answer.Buffer[0]; //    -  
        }
        else    return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//--- 1W --------------------------------------------------------------------
//---------------------------------------------------------------------------
//---  Reset  1W ---------------------------------------------------
unsigned char SendReset_1W(HANDLE Port, bool Control)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x60;               //   (0x60 - SendReset_1W)
  if(WriteData(Port,Request))          //   UART
  {     if(Control==true)             //   
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0) return Answer.Buffer[0]; //    -  
                else               return 0xFE; //   (ReadError)
        }
        else return 0x0; //    - ,   
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
//---    1W ----------------------------------------------------
unsigned int SendByte_1W(HANDLE Port, bool Control, unsigned char Byte)
{ Result        Request;        //    
  Result        Answer;         //    
  int           Temp;           //    
  //(   -    ,   - )
  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  if(Control==true)
  {     Request.Size=1;                       //  
        Request.Buffer[0]=0x61;               //   (0x61 - SendByte)
        if(WriteData(Port,Request))          //   UART
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0)
                {       Temp=Answer.Buffer[0]; //    - 
                        if(Temp==0)            //     
                        {       Request.Buffer[0]=Byte; //   ( )
                                if(WriteData(Port,Request))          //   UART
                                {       Answer = ReadData(Port,1);  //  1   UART
                                        if(Answer.Size!=0)
                                        {       Temp=Answer.Buffer[0]<<8;
                                                return Temp; //    -  
                                        }
                                        else
                                        {       Temp=0xFE<<8;
                                                return Temp; //   (ReadError)
                                        }
                                }
                                else //     
                                {       Temp=0xFF<<8; //   (WriteError)
                                        return Temp;
                                }
                        }
                        else    return Temp;  //   
                }
                else
                {       Temp=0xFE;
                        return Temp; //   (ReadError)
                }
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
  else
  {     Request.Size=2;                       //  
        Request.Buffer[0]=0x61;               //   (0x61 - SendByte)
        Request.Buffer[1]=Byte;               //   ( )
        if(WriteData(Port,Request))          //   UART
        {       Temp=0x0;
                return Temp; //    - ,   
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
}
//---------------------------------------------------------------------------
//---     1W ------------------------------------------------
Result ReadByte_1W(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Answer.Size=0;
  Request.Size=1;                       //  
  Request.Buffer[0]=0x62;              //   (0x62 - ReadByte_1W)
  if(WriteData(Port,Request))         //   UART
  {     Answer = ReadData(Port,1);   //  1   UART
        return Answer;
  }
  else
  {     Answer.Buffer[0]=0xFF;  //   (WriteError)
        return Answer;          //    = 0
  }
}
//---------------------------------------------------------------------------
//---    1W -----------------------------------------------------
unsigned int SendBit_1W(HANDLE Port, bool Control, unsigned char Byte) //    Byte    
{ Result        Request;        //    
  Result        Answer;         //    
  int           Temp;           //    
  //(   -    ,   - )
  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  if(Control==true)
  {     Request.Size=1;                       //  
        Request.Buffer[0]=0x63;               //   (0x63 - SendBit)
        if(WriteData(Port,Request))          //   UART
        {       Answer = ReadData(Port,1);  //  1   UART
                if(Answer.Size!=0)
                {       Temp=Answer.Buffer[0]; //    - 
                        if(Temp==0)            //     
                        {       Request.Buffer[0]=Byte; //   ( )
                                if(WriteData(Port,Request))          //   UART
                                {       Answer = ReadData(Port,1);  //  1   UART
                                        if(Answer.Size!=0)
                                        {       Temp=Answer.Buffer[0]<<8;
                                                return Temp; //    -  
                                        }
                                        else
                                        {       Temp=0xFE<<8;
                                                return Temp; //   (ReadError)
                                        }
                                }
                                else //     
                                {       Temp=0xFF<<8; //   (WriteError)
                                        return Temp;
                                }
                        }
                        else    return Temp;  //   
                }
                else
                {       Temp=0xFE;
                        return Temp; //   (ReadError)
                }
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
  else
  {     Request.Size=2;                       //  
        Request.Buffer[0]=0x63;               //   (0x63 - SendBit)
        Request.Buffer[1]=Byte;               //   ( )
        if(WriteData(Port,Request))          //   UART
        {       Temp=0x0;
                return Temp; //    - ,   
        }
        else
        {       Temp=0xFF;
                return Temp; //   (WriteError)
        }
  }
}
//---------------------------------------------------------------------------
//---     1W -----------------------------------------------
unsigned char ReadBit_1W(HANDLE Port)
{ Result        Request;        //    
  Result        Answer;         //    

  memset(Request.Buffer,0,BUFSIZE);     //  
  memset(Answer.Buffer,0,BUFSIZE);     //  
  Request.Size=1;                       //  
  Request.Buffer[0]=0x64;               //   (0x64 - ReadBit_1W)
  if(WriteData(Port,Request))          //   UART
  {     Answer = ReadData(Port,1);  //  1   UART
        if(Answer.Size!=0)
        {       if      (Answer.Buffer[0]==0x0F) Answer.Buffer[0]=0;
                else if (Answer.Buffer[0]==0x8F) Answer.Buffer[0]=1;
                return Answer.Buffer[0]; //    -  
        }
        else    return 0xFE; //   (ReadError)
  }
  else return 0xFF; //   (WriteError)
}
//---------------------------------------------------------------------------
