//---------------------------------------------------------------------------
#define BUFSIZE 10
#ifndef unit1H
#define unit1H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
//---------------------------------------------------------------------------
//INTERNAL VARIABLES AND FUNCTIONS
OVERLAPPED Ovrlp_wr, Ovrlp_rd;

struct Result {unsigned int Size; unsigned char Buffer[BUFSIZE];};

bool    WriteData(HANDLE Port, Result Request);
Result  ReadData(HANDLE Port, unsigned int Size);
//---------------------------------------------------------------------------
//EXPORTED FUNCTIONS
extern "C" HANDLE __declspec(dllexport) ConnectPort(char *PortName); //   ,  Handle
extern "C" HANDLE __declspec(dllexport) DisconnectPort(HANDLE Port); //  Handle,  Handle
//--- Common ---
extern "C" unsigned char __declspec(dllexport) ResetDevice        (HANDLE Port, bool Control); //  
extern "C" unsigned char __declspec(dllexport) InterfaceChoiceI2C (HANDLE Port, bool Control); //  I2C
extern "C" unsigned char __declspec(dllexport) InterfaceChoiceSPI (HANDLE Port, bool Control); //  SPI
extern "C" unsigned char __declspec(dllexport) InterfaceChoice1W  (HANDLE Port, bool Control); //  1W
extern "C" unsigned char __declspec(dllexport) ReadError          (HANDLE Port);               //  
extern "C" unsigned char __declspec(dllexport) SaveToEPROM        (HANDLE Port, bool Control); //    EPROM
extern "C" Result        __declspec(dllexport) ReadFromEPROM      (HANDLE Port);               //    EPROM
extern "C" unsigned char __declspec(dllexport) EnableReports      (HANDLE Port);               //  
extern "C" unsigned char __declspec(dllexport) DisableReports     (HANDLE Port);               //  
extern "C" unsigned char __declspec(dllexport) EnableAutoload     (HANDLE Port, bool Control); //   
extern "C" unsigned char __declspec(dllexport) DisableAutoload    (HANDLE Port, bool Control); //   
extern "C" unsigned char __declspec(dllexport) ReadCommonConfig   (HANDLE Port);               //   CommonConfig
extern "C" unsigned char __declspec(dllexport) ReadVersion        (HANDLE Port);               //    
//--- I/O ---
extern "C" unsigned char __declspec(dllexport) IO0ConfigOutput    (HANDLE Port, bool Control); // I/O_0  
extern "C" unsigned char __declspec(dllexport) IO0ConfigInput     (HANDLE Port, bool Control); // I/O_0  
extern "C" unsigned char __declspec(dllexport) IO0Output0         (HANDLE Port, bool Control); // I/O_0=0 ()
extern "C" unsigned char __declspec(dllexport) IO0Output1         (HANDLE Port, bool Control); // I/O_0=1 ()
extern "C" unsigned char __declspec(dllexport) IO1ConfigOutput    (HANDLE Port, bool Control); // I/O_1  
extern "C" unsigned char __declspec(dllexport) IO1ConfigInput     (HANDLE Port, bool Control); // I/O_1  
extern "C" unsigned char __declspec(dllexport) IO1Output0         (HANDLE Port, bool Control); // I/O_1=0 ()
extern "C" unsigned char __declspec(dllexport) IO1Output1         (HANDLE Port, bool Control); // I/O_1=1 ()
extern "C" unsigned char __declspec(dllexport) IO2ConfigOutput    (HANDLE Port, bool Control); // I/O_2  
extern "C" unsigned char __declspec(dllexport) IO2ConfigInput     (HANDLE Port, bool Control); // I/O_2  
extern "C" unsigned char __declspec(dllexport) IO2Output0         (HANDLE Port, bool Control); // I/O_2=0 ()
extern "C" unsigned char __declspec(dllexport) IO2Output1         (HANDLE Port, bool Control); // I/O_2=1 ()
extern "C" unsigned char __declspec(dllexport) TestIO_0           (HANDLE Port);               //   I/O_0
extern "C" unsigned char __declspec(dllexport) TestIO_1           (HANDLE Port);               //   I/O_1
extern "C" unsigned char __declspec(dllexport) TestIO_2           (HANDLE Port);               //   I/O_2
extern "C" unsigned char __declspec(dllexport) SetIOG             (HANDLE Port, bool Control); //  I/O_0,1  
//--- I2C ---
extern "C" unsigned char __declspec(dllexport) SendStart_I2C      (HANDLE Port, bool Control); //  START-
extern "C" unsigned char __declspec(dllexport) SendStop_I2C       (HANDLE Port, bool Control); //  STOP-
extern "C" unsigned int  __declspec(dllexport) SendByte_I2C       (HANDLE Port, bool Control, unsigned char Byte); //    I2C
extern "C" Result        __declspec(dllexport) ReadByteA_I2C      (HANDLE Port);               //     ACK
extern "C" Result        __declspec(dllexport) ReadByte_I2C       (HANDLE Port);               //      ACK
extern "C" unsigned char __declspec(dllexport) ClearCS_I2C        (HANDLE Port, bool Control); //  CS  
extern "C" unsigned char __declspec(dllexport) SetCS_I2C          (HANDLE Port, bool Control); //  CS  
extern "C" unsigned char __declspec(dllexport) ReadCS_I2C         (HANDLE Port);               //    CS
//--- SPI ---
extern "C" unsigned int  __declspec(dllexport) LoadConfig_SPI     (HANDLE Port, bool Control, unsigned char Byte); //   SPI
extern "C" unsigned char __declspec(dllexport) ReadConfig_SPI     (HANDLE Port);               //   SPI
extern "C" unsigned int  __declspec(dllexport) LoadPaketSize_SPI  (HANDLE Port, bool Control, unsigned char Byte); //    SPI
extern "C" Result        __declspec(dllexport) ReadPaketSize_SPI  (HANDLE Port);               //    SPI
extern "C" unsigned int  __declspec(dllexport) LoadPaket_SPI      (HANDLE Port, bool Control, Result Input); //   SPI    
extern "C" Result        __declspec(dllexport) ReadPaket_SPI      (HANDLE Port);               //   SPI    
extern "C" unsigned char __declspec(dllexport) StartChange_SPI    (HANDLE Port, bool Control); //        SPI
extern "C" unsigned char __declspec(dllexport) ClearSS_SPI        (HANDLE Port, bool Control); //  SS  
extern "C" unsigned char __declspec(dllexport) SetSS_SPI          (HANDLE Port, bool Control); //  SS  
extern "C" unsigned char __declspec(dllexport) ReadSS_SPI         (HANDLE Port);               //    SS
//--- 1W ---
extern "C" unsigned char __declspec(dllexport) SendReset_1W       (HANDLE Port, bool Control); //    Reset
extern "C" unsigned int  __declspec(dllexport) SendByte_1W        (HANDLE Port, bool Control, unsigned char Byte); //    1W
extern "C" Result        __declspec(dllexport) ReadByte_1W        (HANDLE Port);               //     1W
extern "C" unsigned int  __declspec(dllexport) SendBit_1W         (HANDLE Port, bool Control, unsigned char Byte); //    1W (   Byte)
extern "C" unsigned char __declspec(dllexport) ReadBit_1W         (HANDLE Port);               //     1W
//---------------------------------------------------------------------------
#endif
